Index: branches/ProblemRefactoring/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchContext.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchContext.cs	(revision 14429)
+++ branches/ProblemRefactoring/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchContext.cs	(revision 14429)
@@ -0,0 +1,76 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Algorithms.SingleObjective;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.LocalSearch {
+  [Item("LocalSearchContext", "")]
+  [StorableClass]
+  public class LocalSearchContext<TProblem, TEncoding, TSolution> : HeuristicAlgorithmContext<TProblem, TEncoding, TSolution>,
+      ISingleObjectiveSolutionContext<TSolution>, IImprovementStepsContext, IIterationsContext
+      where TProblem : class, ISingleObjectiveProblem<TEncoding, TSolution>, ISingleObjectiveProblemDefinition<TEncoding, TSolution> // need both !?
+      where TEncoding : class, IEncoding<TSolution>
+      where TSolution: class, ISolution {
+
+    [Storable]
+    private ISingleObjectiveSolutionScope<TSolution> solution;
+    public ISingleObjectiveSolutionScope<TSolution> Solution {
+      get { return solution; }
+      set {
+        solution = value;
+        if (Scope.SubScopes.Count == 0)
+          Scope.SubScopes.Add(solution);
+        else Scope.SubScopes[0] = solution;
+      }
+    }
+
+    [Storable]
+    private int iterations;
+    public int Iterations {
+      get { return iterations; }
+      set { iterations = value; }
+    }
+
+    [Storable]
+    private int improvementSteps;
+    public int ImprovementSteps {
+      get { return improvementSteps; }
+      set { improvementSteps = value; }
+    }
+
+    [StorableConstructor]
+    private LocalSearchContext(bool deserializing) : base(deserializing) { }
+    private LocalSearchContext(LocalSearchContext<TProblem, TEncoding, TSolution> original, Cloner cloner)
+      : base(original, cloner) { }
+    public LocalSearchContext() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new LocalSearchContext<TProblem, TEncoding, TSolution>(this, cloner);
+    }
+
+    IScope ISolutionContext.Solution { get { return solution; } }
+    ISolutionScope<TSolution> ISolutionContext<TSolution>.Solution { get { return solution; } }
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Core/3.3/Attributes/ItemAttribute.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Core/3.3/Attributes/ItemAttribute.cs	(revision 13469)
+++ branches/ProblemRefactoring/HeuristicLab.Core/3.3/Attributes/ItemAttribute.cs	(revision 14429)
@@ -39,12 +39,12 @@
       set { description = value == null ? string.Empty : value; }
     }
+    public bool ExcludeGenericTypeInfo { get; set; }
 
-    public ItemAttribute() {
-      Name = string.Empty;
-      Description = string.Empty;
-    }
-    public ItemAttribute(string name, string description) {
+    public ItemAttribute() : this(string.Empty, string.Empty, false) { }
+    public ItemAttribute(string name, string description) : this(name, description, false) { }
+    public ItemAttribute(string name, string description, bool excludeGenericTypeInfo) {
       Name = name;
       Description = description;
+      ExcludeGenericTypeInfo = excludeGenericTypeInfo;
     }
 
@@ -52,6 +52,7 @@
       object[] attribs = type.GetCustomAttributes(typeof(ItemAttribute), false);
       if (attribs.Length > 0) {
-        string name = ((ItemAttribute)attribs[0]).Name;
-        if (type.IsGenericType) {
+        var attribute = (ItemAttribute)attribs[0];
+        string name = attribute.Name;
+        if (!attribute.ExcludeGenericTypeInfo && type.IsGenericType) {
           name += "<";
           Type[] typeParams = type.GetGenericArguments();
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/NPointCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/NPointCrossover.cs	(revision 13469)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/NPointCrossover.cs	(revision 14429)
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -70,17 +71,17 @@
     /// <param name="n">Number of crossover points.</param>
     /// <returns>The newly created binary vector, resulting from the N point crossover.</returns>
-    public static BinaryVector Apply(IRandom random, BinaryVector parent1, BinaryVector parent2, IntValue n) {
+    public static BinaryVector Apply(IRandom random, BinaryVector parent1, BinaryVector parent2, int n) {
       if (parent1.Length != parent2.Length)
         throw new ArgumentException("NPointCrossover: The parents are of different length.");
 
-      if (n.Value > parent1.Length)
+      if (n > parent1.Length)
         throw new ArgumentException("NPointCrossover: There cannot be more breakpoints than the size of the parents.");
 
-      if (n.Value < 1)
+      if (n < 1)
         throw new ArgumentException("NPointCrossover: N cannot be < 1.");
 
       int length = parent1.Length;
       bool[] result = new bool[length];
-      int[] breakpoints = new int[n.Value];
+      int[] breakpoints = new int[n];
 
       //choose break points
@@ -90,5 +91,5 @@
         breakpointPool.Add(i);
 
-      for (int i = 0; i < n.Value; i++) {
+      for (int i = 0; i < n; i++) {
         int index = random.Next(breakpointPool.Count);
         breakpoints[i] = breakpointPool[index];
@@ -137,5 +138,40 @@
       if (NParameter.ActualValue == null) throw new InvalidOperationException("NPointCrossover: Parameter " + NParameter.ActualName + " could not be found.");
 
-      return Apply(random, parents[0], parents[1], NParameter.ActualValue);
+      return Apply(random, parents[0], parents[1], NParameter.ActualValue.Value);
+    }
+  }
+
+  [Item("N-point Crossover", "", ExcludeGenericTypeInfo = true)]
+  [StorableClass]
+  public sealed class NPointCrossover<TContext> : ParameterizedNamedItem, IBinaryCrossover<TContext>
+    where TContext : IMatingContext<BinaryVector>, IStochasticContext {
+
+    [Storable]
+    private IValueParameter<IntValue> nparameter;
+    public int N {
+      get { return nparameter.Value.Value; }
+      set {
+        if (value < 1) throw new ArgumentException("Cannot set N to less than 1.");
+        nparameter.Value.Value = value;
+      }
+    }
+
+    [StorableConstructor]
+    private NPointCrossover(bool deserializing) : base(deserializing) { }
+    private NPointCrossover(NPointCrossover<TContext> original, Cloner cloner)
+      : base(original, cloner) {
+      nparameter = cloner.Clone(original.nparameter);
+    }
+    public NPointCrossover() {
+      Parameters.Add(nparameter = new ValueParameter<IntValue>("N", "The number of crossover points.", new IntValue(1)));
+    }
+
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new NPointCrossover<TContext>(this, cloner);
+    }
+
+    public void Cross(TContext context) {
+      context.Child.Solution = NPointCrossover.Apply(context.Random, context.Parents.Item1.Solution, context.Parents.Item2.Solution, N);
     }
   }
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/SinglePointCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/SinglePointCrossover.cs	(revision 13469)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/SinglePointCrossover.cs	(revision 14429)
@@ -57,5 +57,5 @@
       if (parents.Length != 2) throw new ArgumentException("ERROR in SinglePointCrossover: The number of parents is not equal to 2");
 
-      return NPointCrossover.Apply(random, parents[0], parents[1], new IntValue(1));
+      return NPointCrossover.Apply(random, parents[0], parents[1], 1);
     }
   }
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj	(revision 13469)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/HeuristicLab.Encodings.BinaryVectorEncoding-3.3.csproj	(revision 14429)
@@ -126,4 +126,5 @@
     <Compile Include="Crossovers\NPointCrossover.cs" />
     <Compile Include="BinaryVector.cs" />
+    <Compile Include="Interfaces\IBinaryLocalSearch.cs" />
     <Compile Include="Interfaces\IBinaryVectorMultiNeighborhoodShakingOperator.cs" />
     <Compile Include="Interfaces\IBinaryVectorSolutionsOperator.cs" />
@@ -139,4 +140,8 @@
     <Compile Include="BinaryVectorManipulator.cs" />
     <Compile Include="Interfaces\IBinaryVectorMoveOperator.cs" />
+    <Compile Include="LocalSearch\ExhaustiveBitflip.cs" />
+    <Compile Include="Manipulators\MultiBitflipManipulator.cs" />
+    <Compile Include="Manipulators\SingleBitflipManipulator.cs" />
+    <Compile Include="Manipulators\BitflipManipulator.cs" />
     <Compile Include="Manipulators\SomePositionsBitflipManipulator.cs" />
     <Compile Include="Manipulators\SinglePositionBitflipManipulator.cs" />
@@ -205,4 +210,8 @@
       <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
       <Private>False</Private>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Random\3.3\HeuristicLab.Random-3.3.csproj">
+      <Project>{F4539FB6-4708-40C9-BE64-0A1390AEA197}</Project>
+      <Name>HeuristicLab.Random-3.3</Name>
     </ProjectReference>
   </ItemGroup>
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Interfaces/IBinaryLocalSearch.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Interfaces/IBinaryLocalSearch.cs	(revision 14429)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Interfaces/IBinaryLocalSearch.cs	(revision 14429)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Optimization.LocalSearch;
+
+namespace HeuristicLab.Encodings.BinaryVectorEncoding {
+  public interface IBinaryLocalSearch<TContext> : ILocalSearch<TContext> {
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Interfaces/IBinaryVectorCrossover.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Interfaces/IBinaryVectorCrossover.cs	(revision 13469)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Interfaces/IBinaryVectorCrossover.cs	(revision 14429)
@@ -22,4 +22,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Crossover;
 
 namespace HeuristicLab.Encodings.BinaryVectorEncoding {
@@ -31,3 +32,6 @@
     ILookupParameter<BinaryVector> ChildParameter { get; }
   }
+
+  // TODO: probably unecessary
+  public interface IBinaryCrossover<TContext> : ICrossover<TContext> { }
 }
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/LocalSearch/ExhaustiveBitflip.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/LocalSearch/ExhaustiveBitflip.cs	(revision 14429)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/LocalSearch/ExhaustiveBitflip.cs	(revision 14429)
@@ -0,0 +1,113 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Encodings.BinaryVectorEncoding.LocalSearch {
+  [Item("Exhaustive Bitflip Local Search (binary)", "", ExcludeGenericTypeInfo = true)]
+  [StorableClass]
+  public class ExhaustiveBitflip<TProblem, TContext> : NamedItem, IBinaryLocalSearch<TContext>
+      where TProblem : class, ISingleObjectiveProblemDefinition<BinaryVectorEncoding, BinaryVector>, ISingleObjectiveProblem<BinaryVectorEncoding, BinaryVector> // need both, because one has Maximization, the other only the IParameter
+      where TContext : IProblemContext<TProblem, BinaryVectorEncoding, BinaryVector>,
+                       ISingleObjectiveSolutionContext<BinaryVector>, IStochasticContext,
+                       IEvaluatedSolutionsContext, ILongRunningOperationContext {
+
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    public override bool CanChangeDescription {
+      get { return false; }
+    }
+
+    [StorableConstructor]
+    protected ExhaustiveBitflip(bool deserializing) : base(deserializing) { }
+    protected ExhaustiveBitflip(ExhaustiveBitflip<TProblem, TContext> original, Cloner cloner) : base(original, cloner) { }
+    public ExhaustiveBitflip() : base() {
+      name = ItemName;
+      description = ItemDescription;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExhaustiveBitflip<TProblem, TContext>(this, cloner);
+    }
+
+    public void Optimize(TContext context) {
+      var quality = context.Solution.Fitness;
+      try {
+        var result = Search(context.Random, context.Solution.Solution, ref quality,
+          context.Problem.Maximization, context.Problem.Evaluate, context.CancellationToken);
+        context.IncEvaluatedSolutions(result.Item1);
+        var stepsContext = context as IImprovementStepsContext;
+        if (stepsContext != null)
+          stepsContext.ImprovementSteps = result.Item2;
+      } finally {
+        context.Solution.Fitness = quality;
+      }
+    }
+
+    private static bool IsBetter(bool maximization, double a, double b) {
+      return maximization && a > b
+        || !maximization && a < b;
+    }
+
+    public static Tuple<int, int> Search(IRandom random, BinaryVector solution, ref double quality, bool maximization, Func<BinaryVector, IRandom, double> evalFunc, CancellationToken token, bool[] subspace = null) {
+      if (double.IsNaN(quality)) quality = evalFunc(solution, null);
+      var improved = false;
+      var order = Enumerable.Range(0, solution.Length).Shuffle(random).ToArray();
+      var lastImp = -1;
+      var steps = 0;
+      var evaluations = 0;
+      do {
+        improved = false;
+        for (var i = 0; i < solution.Length; i++) {
+          // in case we didn't make an improvement this round and arrived at the index of the last improvement
+          // break means we don't need to try the remaining moves again as they have brought no improvement
+          if (!improved && lastImp == i) break;
+          var idx = order[i];
+          if (subspace != null && !subspace[idx]) continue;
+          // bitflip the solution
+          solution[idx] = !solution[idx];
+          var after = evalFunc(solution, null);
+          evaluations++;
+          if (IsBetter(maximization, after, quality)) {
+            steps++;
+            quality = after;
+            lastImp = i;
+            improved = true;
+          } else {
+            // undo the bitflip in case no improvement was made
+            solution[idx] = !solution[idx];
+          }
+          token.ThrowIfCancellationRequested();
+        }
+      } while (improved);
+
+      return Tuple.Create(evaluations, steps);
+    }
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Manipulators/BitflipManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Manipulators/BitflipManipulator.cs	(revision 14429)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Manipulators/BitflipManipulator.cs	(revision 14429)
@@ -0,0 +1,42 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Manipulation;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.BinaryVectorEncoding {
+  [Item("Bitflip Manipulator", "")]
+  [StorableClass]
+  public abstract class BitflipManipulator<TContext> : ParameterizedNamedItem, IManipulator<TContext>
+      where TContext : ISingleObjectiveSolutionContext<BinaryVector>, IStochasticContext {
+
+    [StorableConstructor]
+    protected BitflipManipulator(bool deserializing) : base(deserializing) { }
+    protected BitflipManipulator(BitflipManipulator<TContext> original, Cloner cloner)
+      : base(original, cloner) { }
+    public BitflipManipulator() { }
+
+    public abstract void Manipulate(TContext context);
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Manipulators/MultiBitflipManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Manipulators/MultiBitflipManipulator.cs	(revision 14429)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Manipulators/MultiBitflipManipulator.cs	(revision 14429)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.BinaryVectorEncoding {
+  [Item("Multi Bitflip Manipulator", "", ExcludeGenericTypeInfo = true)]
+  [StorableClass]
+  public sealed class MultiBitflipManipulator<TContext> : BitflipManipulator<TContext>
+      where TContext : ISingleObjectiveSolutionContext<BinaryVector>, IStochasticContext {
+
+    private IValueParameter<PercentValue> RatePerBitParameter {
+      get { return (IValueParameter<PercentValue>)Parameters["RatePerBit"]; }
+    }
+
+    public double RatePerBit {
+      get { return RatePerBitParameter.Value.Value; }
+      set { RatePerBitParameter.Value.Value = value; }
+    }
+
+    [StorableConstructor]
+    private MultiBitflipManipulator(bool deserializing) : base(deserializing) { }
+    private MultiBitflipManipulator(MultiBitflipManipulator<TContext> original, Cloner cloner)
+      : base(original, cloner) { }
+    public MultiBitflipManipulator() {
+      Parameters.Add(new ValueParameter<PercentValue>("RatePerBit", "The probability of mutating each bit (independent of each other).", new PercentValue(0.05)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MultiBitflipManipulator<TContext>(this, cloner);
+    }
+
+    public override void Manipulate(TContext context) {
+      var len = context.Solution.Solution.Length;
+      var rate = RatePerBit;
+
+      for (var idx = 0; idx < len; idx++)
+        if (context.Random.NextDouble() < rate)
+          context.Solution.Solution[idx] = !context.Solution.Solution[idx];
+    }
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Manipulators/SingleBitflipManipulator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Manipulators/SingleBitflipManipulator.cs	(revision 14429)
+++ branches/ProblemRefactoring/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Manipulators/SingleBitflipManipulator.cs	(revision 14429)
@@ -0,0 +1,49 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.BinaryVectorEncoding {
+  [Item("Single Bitflip Manipulator", "", ExcludeGenericTypeInfo = true)]
+  [StorableClass]
+  public sealed class SingleBitflipManipulator<TContext> : BitflipManipulator<TContext>
+      where TContext : ISingleObjectiveSolutionContext<BinaryVector>, IStochasticContext {
+
+    [StorableConstructor]
+    private SingleBitflipManipulator(bool deserializing) : base(deserializing) { }
+    private SingleBitflipManipulator(SingleBitflipManipulator<TContext> original, Cloner cloner)
+      : base(original, cloner) { }
+    public SingleBitflipManipulator() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SingleBitflipManipulator<TContext>(this, cloner);
+    }
+
+    public override void Manipulate(TContext context) {
+      var len = context.Solution.Solution.Length;
+      var idx = context.Random.Next(len);
+      context.Solution.Solution[idx] = !context.Solution.Solution[idx];
+    }
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Optimization/3.3/Algorithms/AlgorithmContext.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Optimization/3.3/Algorithms/AlgorithmContext.cs	(revision 14429)
+++ branches/ProblemRefactoring/HeuristicLab.Optimization/3.3/Algorithms/AlgorithmContext.cs	(revision 14429)
@@ -0,0 +1,73 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Algorithms {
+  [Item("AlgorithmContext", "")]
+  [StorableClass]
+  public abstract class AlgorithmContext : ParameterizedNamedItem, IExecutionContext {
+
+    private IExecutionContext parent;
+    public IExecutionContext Parent {
+      get { return parent; }
+      set { parent = value; }
+    }
+
+    IKeyedItemCollection<string, IParameter> IExecutionContext.Parameters {
+      get { return Parameters; }
+    }
+
+    [Storable]
+    private IScope scope;
+    public IScope Scope {
+      get { return scope; }
+    }
+
+    [StorableConstructor]
+    protected AlgorithmContext(bool deserializing) : base(deserializing) { }
+    protected AlgorithmContext(AlgorithmContext original, Cloner cloner)
+      : base(original, cloner) { }
+    protected AlgorithmContext() : this(new Scope("Scope")) { }
+    protected AlgorithmContext(IScope s) {
+      scope = s;
+    }
+
+
+    public IAtomicOperation CreateOperation(IOperator op) {
+      return new ExecutionContext(parent, op, scope);
+    }
+
+    public IAtomicOperation CreateOperation(IOperator op, IScope s) {
+      return new ExecutionContext(parent, op, s);
+    }
+
+    public IAtomicOperation CreateChildOperation(IOperator op) {
+      return new ExecutionContext(this, op, scope);
+    }
+
+    public IAtomicOperation CreateChildOperation(IOperator op, IScope s) {
+      return new ExecutionContext(this, op, s);
+    }
+  }
+}
